unit Utils;

interface

uses
  Windows, Classes, SysUtils, Forms, Controls, stdctrls, Graphics,
  ShellAPI;

procedure SetControlColor(C: Tcontrol);
procedure SetComboBoxFirst(cbx: TComboBox);
procedure MainFormTrayIcon(Mode: Integer; MsgNum: integer);

implementation

type
  TControlHack = class(TControl)
  published
    property Color;
  end;

procedure SetControlColor(C: TControl);
begin
  if C.Enabled then TControlHack(C).Color := clWindow
               else TControlHack(C).Color := clBtnFace;
end;

procedure SetComboBoxFirst(cbx: TComboBox);
begin
  if (cbx.ItemIndex = -1) and (cbx.Items.Count > 0) then
    cbx.ItemIndex := 0;
end;

procedure MainFormTrayIcon(Mode: Integer; MsgNum: integer);
var Nim: TNotifyIconData; s: string;
begin
  s := Copy(Application.Title, 1, 63);
  FillChar(Nim, SizeOf(Nim), 0);
  with Nim do Begin
    cbSize := SizeOf(Nim);
    Wnd := Application.MainForm.Handle;
    uID := 1;
    uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    hIcon := Application.MainForm.Icon.Handle;
    uCallbackMessage := MsgNum;
    Move(s[1], szTip[0], Length(s));
  end;
  case Mode of
    1: Shell_NotifyIcon(Nim_Add,    @Nim);
    2: Shell_NotifyIcon(Nim_Delete, @Nim);
    3: Shell_NotifyIcon(Nim_Modify, @Nim);
  end;
end;

end.
